org.bdgenomics.adam.rdd.read

# AlignmentRecordRDD

###
Related Docs: object AlignmentRecordRDD | package read

#### case class AlignmentRecordRDD(rdd: RDD[AlignmentRecord], sequences: SequenceDictionary, recordGroups: RecordGroupDictionary) extends AvroReadGroupGenomicRDD[AlignmentRecord, AlignmentRecordRDD] with Product with Serializable

Linear Supertypes
Product, Equals, AvroReadGroupGenomicRDD[AlignmentRecord, AlignmentRecordRDD], AvroGenomicRDD[AlignmentRecord, AlignmentRecordRDD], GenomicRDD[AlignmentRecord, AlignmentRecordRDD], ADAMRDDFunctions[AlignmentRecord], Logging, Serializable, Serializable, AnyRef, Any
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. AlignmentRecordRDD
2. Product
3. Equals
4. AvroReadGroupGenomicRDD
5. AvroGenomicRDD
6. GenomicRDD
7. ADAMRDDFunctions
8. Logging
9. Serializable
10. Serializable
11. AnyRef
12. Any

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1. #### new AlignmentRecordRDD(rdd: RDD[AlignmentRecord], sequences: SequenceDictionary, recordGroups: RecordGroupDictionary)

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

4. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

5. #### def broadcastRegionJoin[X, Y <: GenomicRDD[X, Y], Z <: GenomicRDD[(AlignmentRecord, X), Z]](genomicRdd: GenomicRDD[X, Y])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X]): GenomicRDD[(AlignmentRecord, X), Z]

   Performs a broadcast inner join between this RDD and another RDD.

   Performs a broadcast inner join between this RDD and another RDD.

   In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped.

   genomicRdd

     The right RDD in the join.

   returns

     Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

   Definition Classes
     GenomicRDD

6. #### def broadcastRegionJoinAndGroupByRight[X, Y <: GenomicRDD[X, Y], Z <: GenomicRDD[(Iterable[AlignmentRecord], X), Z]](genomicRdd: GenomicRDD[X, Y])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X]): GenomicRDD[(Iterable[AlignmentRecord], X), Z]

   Performs a broadcast inner join between this RDD and another RDD.

   Performs a broadcast inner join between this RDD and another RDD.

   In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped.

   genomicRdd

     The right RDD in the join.

   returns

     Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

   Definition Classes
     GenomicRDD

7. #### def buildTree(rdd: RDD[(ReferenceRegion, AlignmentRecord)])(implicit tTag: ClassTag[AlignmentRecord]): IntervalArray[ReferenceRegion, AlignmentRecord]

   Attributes
     protected
   Definition Classes
     AlignmentRecordRDD → GenomicRDD

8. #### def clone(): AnyRef

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )

9. #### def computeMismatchingPositions(referenceFile: ReferenceFile, overwriteExistingTags: Boolean = false, validationStringency: ValidationStringency = ValidationStringency.LENIENT): AlignmentRecordRDD

   Computes the mismatching positions field (SAM "MD" tag).

   Computes the mismatching positions field (SAM "MD" tag).

   referenceFile

     A reference file that can be broadcast to all nodes.

   overwriteExistingTags

     If true, overwrites the MD tags on reads where it is already populated. If false, we only tag reads that are currently missing an MD tag. Default is false.

   validationStringency

     If we are recalculating existing tags and we find that the MD tag that was previously on the read doesn't match our new tag, LENIENT will log a warning message, STRICT will throw an exception, and SILENT will ignore. Default is LENIENT.

   returns

     Returns a new AlignmentRecordRDD where all reads have the mismatchingPositions field populated.

10. #### def convertToSam(isSorted: Boolean = false): (RDD[SAMRecordWritable], SAMFileHeader)

    Converts an RDD of ADAM read records into SAM records.

    Converts an RDD of ADAM read records into SAM records.

    returns

      Returns a SAM/BAM formatted RDD of reads, as well as the file header.

11. #### def countKmers(kmerLength: Int): RDD[(String, Long)]

    Cuts reads into _k_-mers, and then counts the number of occurrences of each _k_-mer.

    Cuts reads into _k_-mers, and then counts the number of occurrences of each _k_-mer.

    kmerLength

      The value of _k_ to use for cutting _k_-mers.

    returns

      Returns an RDD containing k-mer/count pairs.

12. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

13. #### def filterByOverlappingRegion(query: ReferenceRegion): AlignmentRecordRDD

    Runs a filter that selects data in the underlying RDD that overlaps a single genomic region.

    Runs a filter that selects data in the underlying RDD that overlaps a single genomic region.

    query

      The region to query for.

    returns

      Returns a new GenomicRDD containing only data that overlaps the query region.

    Definition Classes
      GenomicRDD

14. #### def filterByOverlappingRegions(querys: List[ReferenceRegion]): AlignmentRecordRDD

    Runs a filter that selects data in the underlying RDD that overlaps several genomic regions.

    Runs a filter that selects data in the underlying RDD that overlaps several genomic regions.

    querys

      The regions to query for.

    returns

      Returns a new GenomicRDD containing only data that overlaps the querys region.

    Definition Classes
      GenomicRDD

15. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

16. #### def flagStat(): (FlagStatMetrics, FlagStatMetrics)

    Runs a quality control pass akin to the Samtools FlagStat tool.

    Runs a quality control pass akin to the Samtools FlagStat tool.

    returns

      Returns a tuple of (failedQualityMetrics, passedQualityMetrics)

17. #### def flattenRddByRegions(): RDD[(ReferenceRegion, AlignmentRecord)]

    Attributes
      protected
    Definition Classes
      GenomicRDD

18. #### def fullOuterShuffleRegionJoin[X, Y <: GenomicRDD[X, Y], Z <: GenomicRDD[(Option[AlignmentRecord], Option[X]), Z]](genomicRdd: GenomicRDD[X, Y], optPartitions: Option[Int] = None)(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X]): GenomicRDD[(Option[AlignmentRecord], Option[X]), Z]

    Performs a sort-merge full outer join between this RDD and another RDD.

    Performs a sort-merge full outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a full outer join, if a value from either RDD does not overlap any values in the other RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and values that did not overlap will be paired with a `None`.

    Definition Classes
      GenomicRDD

19. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

20. #### def getReferenceRegions(elem: AlignmentRecord): Seq[ReferenceRegion]

    Returns all reference regions that overlap this read.

    Returns all reference regions that overlap this read.

    If a read is unaligned, it covers no reference region. If a read is aligned we expect it to cover a single region. A chimeric read would cover multiple regions, but we store chimeric reads in a way similar to BAM, where the split alignments are stored in multiple separate reads.

    elem

      Read to produce regions for.

    returns

      The seq of reference regions this read covers.

    Attributes
      protected
    Definition Classes
      AlignmentRecordRDD → GenomicRDD

21. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

22. #### def isTraceEnabled(): Boolean

    Attributes
      protected
    Definition Classes
      Logging

23. #### lazy val jrdd: JavaRDD[AlignmentRecord]

    The underlying RDD of genomic data, as a JavaRDD.

    The underlying RDD of genomic data, as a JavaRDD.

    Definition Classes
      GenomicRDD

24. #### def leftOuterShuffleRegionJoin[X, Y <: GenomicRDD[X, Y], Z <: GenomicRDD[(AlignmentRecord, Option[X]), Z]](genomicRdd: GenomicRDD[X, Y], optPartitions: Option[Int] = None)(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X]): GenomicRDD[(AlignmentRecord, Option[X]), Z]

    Performs a sort-merge left outer join between this RDD and another RDD.

    Performs a sort-merge left outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right RDD that do not overlap a value from the left RDD are dropped. If a value from the left RDD does not overlap any values in the right RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left RDD that did not overlap a key in the right RDD.

    Definition Classes
      GenomicRDD

25. #### def log: Logger

    Attributes
      protected
    Definition Classes
      Logging

26. #### def logDebug(msg: ⇒ String, throwable: Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

27. #### def logDebug(msg: ⇒ String): Unit

    Attributes
      protected
    Definition Classes
      Logging

28. #### def logError(msg: ⇒ String, throwable: Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

29. #### def logError(msg: ⇒ String): Unit

    Attributes
      protected
    Definition Classes
      Logging

30. #### def logInfo(msg: ⇒ String, throwable: Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

31. #### def logInfo(msg: ⇒ String): Unit

    Attributes
      protected
    Definition Classes
      Logging

32. #### def logName: String

    Attributes
      protected
    Definition Classes
      Logging

33. #### def logTrace(msg: ⇒ String, throwable: Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

34. #### def logTrace(msg: ⇒ String): Unit

    Attributes
      protected
    Definition Classes
      Logging

35. #### def logWarning(msg: ⇒ String, throwable: Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

36. #### def logWarning(msg: ⇒ String): Unit

    Attributes
      protected
    Definition Classes
      Logging

37. #### def markDuplicates(): AlignmentRecordRDD

    Marks reads as possible fragment duplicates.

    Marks reads as possible fragment duplicates.

    returns

      A new RDD where reads have the duplicate read flag set. Duplicate reads are NOT filtered out.

38. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

39. #### final def notify(): Unit

    Definition Classes
      AnyRef

40. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

41. #### def pipe[X, Y <: GenomicRDD[X, Y], V <: InFormatter[AlignmentRecord, AlignmentRecordRDD, V]](cmd: String, files: Seq[String] = Seq.empty, environment: Map[String, String] = Map.empty, flankSize: Int = 0)(implicit tFormatterCompanion: InFormatterCompanion[AlignmentRecord, AlignmentRecordRDD, V], xFormatter: OutFormatter[X], convFn: (AlignmentRecordRDD, RDD[X]) ⇒ Y, tManifest: ClassTag[AlignmentRecord], xManifest: ClassTag[X]): Y

    Pipes genomic data to a subprocess that runs in parallel using Spark.

    Pipes genomic data to a subprocess that runs in parallel using Spark.

    Files are substituted in to the command with a $x syntax. E.g., to invoke a command that uses the first file from the files Seq, use $0.

    Pipes require the presence of an InFormatterCompanion and an OutFormatter as implicit values. The InFormatterCompanion should be a singleton whose apply method builds an InFormatter given a specific type of GenomicRDD. The implicit InFormatterCompanion yields an InFormatter which is used to format the input to the pipe, and the implicit OutFormatter is used to parse the output from the pipe.

    X

      The type of the record created by the piped command.

    Y

      A GenomicRDD containing X's.

    V

      The InFormatter to use for formatting the data being piped to the command.

    cmd

      Command to run.

    files

      Files to make locally available to the commands being run. Default is empty.

    environment

      A map containing environment variable/value pairs to set in the environment for the newly created process. Default is empty.

    flankSize

      Number of bases to flank each command invocation by.

    returns

      Returns a new GenomicRDD of type Y.

    Definition Classes
      GenomicRDD

42. #### val rdd: RDD[AlignmentRecord]

    The RDD of genomic data that we are wrapping.

    The RDD of genomic data that we are wrapping.

    Definition Classes
      AlignmentRecordRDD → GenomicRDD → ADAMRDDFunctions

43. #### def realignIndels(consensusModel: ConsensusGenerator = new ConsensusGeneratorFromReads, isSorted: Boolean = false, maxIndelSize: Int = 500, maxConsensusNumber: Int = 30, lodThreshold: Double = 5.0, maxTargetSize: Int = 3000, maxReadsPerTarget: Int = 20000, optReferenceFile: Option[ReferenceFile] = None, unclipReads: Boolean = false): AlignmentRecordRDD

    Realigns indels using a concensus-based heuristic.

    Realigns indels using a concensus-based heuristic.

    consensusModel

      The model to use for generating consensus sequences to realign against.

    isSorted

      If the input data is sorted, setting this parameter to true avoids a second sort.

    maxIndelSize

      The size of the largest indel to use for realignment.

    maxConsensusNumber

      The maximum number of consensus sequences to realign against per target region.

    lodThreshold

      Log-odds threshold to use when realigning; realignments are only finalized if the log-odds threshold is exceeded.

    maxTargetSize

      The maximum width of a single target region for realignment.

    optReferenceFile

      An optional reference. If not provided, reference will be inferred from MD tags.

    unclipReads

      If true, unclips reads prior to realignment. Else, omits clipped bases during realignment.

    returns

      Returns an RDD of mapped reads which have been realigned.

44. #### def reassembleReadPairs(secondPairRdd: RDD[AlignmentRecord], validationStringency: ValidationStringency = ValidationStringency.LENIENT): AlignmentRecordRDD

    Reassembles read pairs from two sets of unpaired reads.

    Reassembles read pairs from two sets of unpaired reads. The assumption is that the two sets were _originally_ paired together.

    secondPairRdd

      The rdd containing the second read from the pairs.

    validationStringency

      How stringently to validate the reads.

    returns

      Returns an RDD with the pair information recomputed.

    Note

      The RDD that this is called on should be the RDD with the first read from the pair.

45. #### def recalibrateBaseQualities(knownSnps: Broadcast[SnpTable], minAcceptableQuality: Int = 5, optStorageLevel: Option[StorageLevel] = Some(StorageLevel.MEMORY_ONLY)): AlignmentRecordRDD

    Runs base quality score recalibration on a set of reads.

    Runs base quality score recalibration on a set of reads. Uses a table of known SNPs to mask true variation during the recalibration process.

    knownSnps

      A table of known SNPs to mask valid variants.

    minAcceptableQuality

      The minimum quality score to recalibrate.

    optStorageLevel

      An optional storage level to set for the output of the first stage of BQSR. Defaults to StorageLevel.MEMORY_ONLY.

    returns

      Returns an RDD of recalibrated reads.

46. #### val recordGroups: RecordGroupDictionary

    A dictionary describing the read groups attached to this GenomicRDD.

    A dictionary describing the read groups attached to this GenomicRDD.

    Definition Classes
      AlignmentRecordRDD → AvroReadGroupGenomicRDD

47. #### def replaceRdd(newRdd: RDD[AlignmentRecord]): AlignmentRecordRDD

    Attributes
      protected
    Definition Classes
      AlignmentRecordRDD → GenomicRDD

48. #### def replaceRddAndSequences(newRdd: RDD[AlignmentRecord], newSequences: SequenceDictionary): AlignmentRecordRDD

    Replaces the underlying RDD and SequenceDictionary and emits a new object.

    Replaces the underlying RDD and SequenceDictionary and emits a new object.

    newRdd

      New RDD to replace current RDD.

    newSequences

      New sequence dictionary to replace current dictionary.

    returns

      Returns a new AlignmentRecordRDD.

    Attributes
      protected

49. #### def rightOuterBroadcastRegionJoin[X, Y <: GenomicRDD[X, Y], Z <: GenomicRDD[(Option[AlignmentRecord], X), Z]](genomicRdd: GenomicRDD[X, Y])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X]): GenomicRDD[(Option[AlignmentRecord], X), Z]

    Performs a broadcast right outer join between this RDD and another RDD.

    Performs a broadcast right outer join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicRDD

50. #### def rightOuterBroadcastRegionJoinAndGroupByRight[X, Y <: GenomicRDD[X, Y], Z <: GenomicRDD[(Iterable[AlignmentRecord], X), Z]](genomicRdd: GenomicRDD[X, Y])(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X]): GenomicRDD[(Iterable[AlignmentRecord], X), Z]

    Performs a broadcast right outer join between this RDD and another RDD.

    Performs a broadcast right outer join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicRDD

51. #### def rightOuterShuffleRegionJoin[X, Y <: GenomicRDD[X, Y], Z <: GenomicRDD[(Option[AlignmentRecord], X), Z]](genomicRdd: GenomicRDD[X, Y], optPartitions: Option[Int] = None)(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X]): GenomicRDD[(Option[AlignmentRecord], X), Z]

    Performs a sort-merge right outer join between this RDD and another RDD.

    Performs a sort-merge right outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicRDD

52. #### def rightOuterShuffleRegionJoinAndGroupByLeft[X, Y <: GenomicRDD[X, Y], Z <: GenomicRDD[(Option[AlignmentRecord], Iterable[X]), Z]](genomicRdd: GenomicRDD[X, Y], optPartitions: Option[Int] = None)(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X]): GenomicRDD[(Option[AlignmentRecord], Iterable[X]), Z]

    Performs a sort-merge right outer join between this RDD and another RDD, followed by a groupBy on the left value, if not null.

    Performs a sort-merge right outer join between this RDD and another RDD, followed by a groupBy on the left value, if not null.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the RDD. Since this is a right outer join, all values from the right RDD who did not overlap a value from the left RDD are placed into a length-1 Iterable with a `None` key.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left RDD, and all values from the right RDD that did not overlap an item in the left RDD.

    Definition Classes
      GenomicRDD

53. #### def save(filePath: String, isSorted: Boolean): Boolean

    Saves this RDD to disk, with the type identified by the extension.

    Saves this RDD to disk, with the type identified by the extension.

    filePath

      Path to save the file at.

    isSorted

      Whether the file is sorted or not.

    returns

      Returns true if saving succeeded.

54. #### def save(args: ADAMSaveAnyArgs, isSorted: Boolean = false): Boolean

    Saves AlignmentRecords as a directory of Parquet files or as SAM/BAM.

    Saves AlignmentRecords as a directory of Parquet files or as SAM/BAM.

    This method infers the output format from the file extension. Filenames ending in .sam/.bam are saved as SAM/BAM, and all other files are saved as Parquet.

    args

      Save configuration arguments.

    isSorted

      If the output is sorted, this will modify the SAM/BAM header.

    returns

      Returns true if saving succeeded.

55. #### def saveAsFastq(fileName: String, fileName2Opt: Option[String] = None, outputOriginalBaseQualities: Boolean = false, sort: Boolean = false, validationStringency: ValidationStringency = ValidationStringency.LENIENT, persistLevel: Option[StorageLevel] = None): Unit

    Saves reads in FASTQ format.

    Saves reads in FASTQ format.

    fileName

      Path to save files at.

    fileName2Opt

      Optional second path for saving files. If set, two files will be saved.

    outputOriginalBaseQualities

      If true, writes out reads with the base qualities from the original qualities (SAM "OQ") field. If false, writes out reads with the base qualities from the qual field. Default is false.

    sort

      Whether to sort the FASTQ files by read name or not. Defaults to false. Sorting the output will recover pair order, if desired.

    validationStringency

      Iff strict, throw an exception if any read in this RDD is not accompanied by its mate.

    persistLevel

      An optional persistance level to set. If this level is set, then reads will be cached (at the given persistance) level between passes.

56. #### def saveAsPairedFastq(fileName1: String, fileName2: String, outputOriginalBaseQualities: Boolean = false, validationStringency: ValidationStringency = ValidationStringency.LENIENT, persistLevel: Option[StorageLevel] = None): Unit

    Saves these AlignmentRecords to two FASTQ files.

    Saves these AlignmentRecords to two FASTQ files.

    The files are one for the first mate in each pair, and the other for the second mate in the pair.

    fileName1

      Path at which to save a FASTQ file containing the first mate of each pair.

    fileName2

      Path at which to save a FASTQ file containing the second mate of each pair.

    outputOriginalBaseQualities

      If true, writes out reads with the base qualities from the original qualities (SAM "OQ") field. If false, writes out reads with the base qualities from the qual field. Default is false.

    validationStringency

      Iff strict, throw an exception if any read in this RDD is not accompanied by its mate.

    persistLevel

      An optional persistance level to set. If this level is set, then reads will be cached (at the given persistance) level between passes.

57. #### def saveAsParquet(filePath: String): Unit

    Saves this RDD to disk as a Parquet file.

    Saves this RDD to disk as a Parquet file.

    filePath

      Path to save the file at.

    Definition Classes
      AvroGenomicRDD

58. #### def saveAsParquet(filePath: String, blockSize: Integer, pageSize: Integer, compressCodec: CompressionCodecName, disableDictionaryEncoding: Boolean): Unit

    Saves this RDD to disk as a Parquet file.

    Saves this RDD to disk as a Parquet file.

    filePath

      Path to save the file at.

    blockSize

      Size per block.

    pageSize

      Size per page.

    compressCodec

      Name of the compression codec to use.

    disableDictionaryEncoding

      Whether or not to disable bit-packing.

    Definition Classes
      AvroGenomicRDD

59. #### def saveAsParquet(filePath: String, blockSize: Int = 128 * 1024 * 1024, pageSize: Int = 1 * 1024 * 1024, compressCodec: CompressionCodecName = CompressionCodecName.GZIP, disableDictionaryEncoding: Boolean = false): Unit

    Saves this RDD to disk as a Parquet file.

    Saves this RDD to disk as a Parquet file.

    filePath

      Path to save the file at.

    blockSize

      Size per block.

    pageSize

      Size per page.

    compressCodec

      Name of the compression codec to use.

    disableDictionaryEncoding

      Whether or not to disable bit-packing. Default is false.

    Definition Classes
      AvroGenomicRDD

60. #### def saveAsParquet(args: SaveArgs): Unit

    Saves RDD as a directory of Parquet files.

    Saves RDD as a directory of Parquet files.

    The RDD is written as a directory of Parquet files, with Parquet configuration described by the input param args. The provided sequence dictionary is written at args.outputPath/_seqdict.avro as Avro binary.

    args

      Save configuration arguments.

    Definition Classes
      AvroGenomicRDD

61. #### def saveAsSam(filePath: String, asType: SAMFormat, asSingleFile: Boolean, isSorted: Boolean): Unit

    Saves this RDD to disk as a SAM/BAM/CRAM file.

    Saves this RDD to disk as a SAM/BAM/CRAM file.

    filePath

      Path to save the file at.

    asType

      The SAMFormat to save as. If left null, we will infer the format from the file extension.

    asSingleFile

      If true, saves output as a single file.

    isSorted

      If the output is sorted, this will modify the header.

62. #### def saveAsSam(filePath: String, asType: Option[SAMFormat] = None, asSingleFile: Boolean = false, isSorted: Boolean = false, deferMerging: Boolean = false): Unit

    Saves an RDD of ADAM read data into the SAM/BAM format.

    Saves an RDD of ADAM read data into the SAM/BAM format.

    filePath

      Path to save files to.

    asType

      Selects whether to save as SAM, BAM, or CRAM. The default value is None, which means the file type is inferred from the extension.

    asSingleFile

      If true, saves output as a single file.

    isSorted

      If the output is sorted, this will modify the header.

    deferMerging

      If true and asSingleFile is true, we will save the output shards as a headerless file, but we will not merge the shards.

63. #### def saveAsSamString(): String

    Converts an RDD into the SAM spec string it represents.

    Converts an RDD into the SAM spec string it represents.

    This method converts an RDD of AlignmentRecords back to an RDD of SAMRecordWritables and a SAMFileHeader, and then maps this RDD into a string on the driver that represents this file in SAM.

    returns

      A string on the driver representing this RDD of reads in SAM format.

64. #### def saveAvro[U <: SpecificRecordBase](filename: String, sc: SparkContext, schema: Schema, avro: Seq[U])(implicit tUag: ClassTag[U]): Unit

    Saves Avro data to a Hadoop file system.

    Saves Avro data to a Hadoop file system.

    This method uses a SparkContext to identify our underlying file system, which we then save to.

    Frustratingly enough, although all records generated by the Avro IDL compiler have a static SCHEMA$ field, this field does not belong to the SpecificRecordBase abstract class, or the SpecificRecord interface. As such, we must force the user to pass in the schema.

    U

      The type of the specific record we are saving.

    filename

      Path to save records to.

    sc

      SparkContext used for identifying underlying file system.

    schema

      Schema of records we are saving.

    avro

      Seq of records we are saving.

    Attributes
      protected
    Definition Classes
      ADAMRDDFunctions

65. #### def saveMetadata(filePath: String): Unit

    Called in saveAsParquet after saving RDD to Parquet to save metadata.

    Called in saveAsParquet after saving RDD to Parquet to save metadata.

    Writes any necessary metadata to disk. If not overridden, writes the sequence dictionary to disk as Avro.

    Attributes
      protected
    Definition Classes
      AvroReadGroupGenomicRDD → AvroGenomicRDD

66. #### def saveRddAsParquet(filePath: String, blockSize: Int = 128 * 1024 * 1024, pageSize: Int = 1 * 1024 * 1024, compressCodec: CompressionCodecName = CompressionCodecName.GZIP, disableDictionaryEncoding: Boolean = false, schema: Option[Schema] = None): Unit

    Saves an RDD of Avro data to Parquet.

    Saves an RDD of Avro data to Parquet.

    filePath

      The path to save the file to.

    blockSize

      The size in bytes of blocks to write.

    pageSize

      The size in bytes of pages to write.

    compressCodec

      The compression codec to apply to pages.

    disableDictionaryEncoding

      If false, dictionary encoding is used. If true, delta encoding is used.

    schema

      The schema to set.

    Attributes
      protected
    Definition Classes
      ADAMRDDFunctions

67. #### def saveRddAsParquet(args: SaveArgs): Unit

    Attributes
      protected
    Definition Classes
      ADAMRDDFunctions

68. #### val sequences: SequenceDictionary

    The sequence dictionary describing the reference assembly this data is aligned to.

    The sequence dictionary describing the reference assembly this data is aligned to.

    Definition Classes
      AlignmentRecordRDD → GenomicRDD

69. #### def shuffleRegionJoin[X, Y <: GenomicRDD[X, Y], Z <: GenomicRDD[(AlignmentRecord, X), Z]](genomicRdd: GenomicRDD[X, Y], optPartitions: Option[Int] = None)(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X]): GenomicRDD[(AlignmentRecord, X), Z]

    Performs a sort-merge inner join between this RDD and another RDD.

    Performs a sort-merge inner join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicRDD

70. #### def shuffleRegionJoinAndGroupByLeft[X, Y <: GenomicRDD[X, Y], Z <: GenomicRDD[(AlignmentRecord, Iterable[X]), Z]](genomicRdd: GenomicRDD[X, Y], optPartitions: Option[Int] = None)(implicit tTag: ClassTag[AlignmentRecord], xTag: ClassTag[X]): GenomicRDD[(AlignmentRecord, Iterable[X]), Z]

    Performs a sort-merge inner join between this RDD and another RDD, followed by a groupBy on the left value.

    Performs a sort-merge inner join between this RDD and another RDD, followed by a groupBy on the left value.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped. In the same operation, we group all values by the left item in the RDD.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left RDD..

    Definition Classes
      GenomicRDD

71. #### def sort(): AlignmentRecordRDD

    Sorts our genome aligned data by reference positions, with contigs ordered by index.

    Sorts our genome aligned data by reference positions, with contigs ordered by index.

    returns

      Returns a new RDD containing sorted data.

    Definition Classes
      GenomicRDD
    Note

      Does not support data that is unaligned or where objects align to multiple positions.

    See also

      sortLexicographically

72. #### def sortLexicographically(): AlignmentRecordRDD

    Sorts our genome aligned data by reference positions, with contigs ordered lexicographically.

    Sorts our genome aligned data by reference positions, with contigs ordered lexicographically.

    returns

      Returns a new RDD containing sorted data.

    Definition Classes
      GenomicRDD
    Note

      Does not support data that is unaligned or where objects align to multiple positions.

    See also

      sort

73. #### def sortReadsByReferencePosition(): AlignmentRecordRDD

    Sorts our read data by reference positions, with contigs ordered by name.

    Sorts our read data by reference positions, with contigs ordered by name.

    Sorts reads by the location where they are aligned. Unaligned reads are put at the end and sorted by read name. Contigs are ordered lexicographically.

    returns

      Returns a new RDD containing sorted reads.

    See also

      sortReadsByReferencePositionAndIndex

74. #### def sortReadsByReferencePositionAndIndex(): AlignmentRecordRDD

    Sorts our read data by reference positions, with contigs ordered by index.

    Sorts our read data by reference positions, with contigs ordered by index.

    Sorts reads by the location where they are aligned. Unaligned reads are put at the end and sorted by read name. Contigs are ordered by index that they are ordered in the SequenceDictionary.

    returns

      Returns a new RDD containing sorted reads.

    See also

      sortReadsByReferencePosition

75. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

76. #### def toCoverage(collapse: Boolean = true): CoverageRDD

    Converts this set of reads into a corresponding CoverageRDD.

    Converts this set of reads into a corresponding CoverageRDD.

    collapse

      Determines whether to merge adjacent coverage elements with the same score a single coverage.

    returns

      CoverageRDD containing mapped RDD of Coverage.

77. #### def toFragments: FragmentRDD

    Convert this set of reads into fragments.

    Convert this set of reads into fragments.

    returns

      Returns a FragmentRDD where all reads have been grouped together by the original sequence fragment they come from.

78. #### def transform(tFn: (RDD[AlignmentRecord]) ⇒ RDD[AlignmentRecord]): AlignmentRecordRDD

    Applies a function that transforms the underlying RDD into a new RDD.

    Applies a function that transforms the underlying RDD into a new RDD.

    tFn

      A function that transforms the underlying RDD.

    returns

      A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) is copied without modification.

    Definition Classes
      GenomicRDD

79. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

80. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

81. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

### Inherited from Product

### Inherited from Equals

### Inherited from AvroReadGroupGenomicRDD[AlignmentRecord, AlignmentRecordRDD]

### Inherited from AvroGenomicRDD[AlignmentRecord, AlignmentRecordRDD]

### Inherited from GenomicRDD[AlignmentRecord, AlignmentRecordRDD]

### Inherited from ADAMRDDFunctions[AlignmentRecord]

### Inherited from Logging

### Inherited from Serializable

### Inherited from AnyRef

### Inherited from Any

### Ungrouped